window.Gleam.initSearch([{"doc":"popcicle","title":"popcicle","content":"# popcicle\n\n[![Package Version](https://img.shields.io/hexpm/v/popcicle)](https://hex.pm/packages/popcicle)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/popcicle/)\n\n```sh\ngleam add popcicle@1\n```\n```gleam\nimport popcicle\nimport lustre/element/html\nimport lustre/attribute\n\npub fn main() {\n    popcicle.popcicle(\n        html.button([], [ // This is the button to open the popover\n            html.text(&quot;Click me&quot;)\n        ]),\n        popcicle.UnderCenter, // This is where the popover should be positioned, more info below\n        html.div([\n            attribute.class(&quot;p-4 w-72 outline-none shadow-sm bg-white rounded-md border border-zinc-200 overflow-hidden&quot;)\n        ], [\n            html.text(&quot;My popover&quot;)\n        ]),\n        popcicle.Click // Wether the popover should be shown on click (popcicle.Click) or on hover (popcicle.Hover)\n    )\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/popcicle&gt;.\n\n## Are they styled by default?\n\nNo, however there are ready-made styles popovers that you can simply copy into your project and use that are based on shadcn/ui:\n\nPreviews can be found on [https://popcicle.keii.dev](https://popcicle.keii.dev)\n\n* [Dropdown Menu](https://github.com/dinkelspiel/popcicle/blob/master/examples/dropdown_menu.gleam)\n \n&lt;img width=&quot;500px&quot; src=&quot;https://github.com/dinkelspiel/popcicle/raw/master/examples/dropdown_menu.png&quot;&gt;\n\n## Do i have to use Lustre\n\nYes.\n\n","url":"index.html"},{"doc":"popcicle","title":"PopcicleConfig","content":"pub type PopcicleConfig {\n  PopcicleConfig(css: String, click_gap: Int, hover_gap: Int)\n}\n\nPopcicleConfig(css: String, click_gap: Int, hover_gap: Int)\n\n\nSynonyms:\npopcicle.PopcicleConfig\npopcicle PopcicleConfig","url":"popcicle.html#PopcicleConfig"},{"doc":"popcicle","title":"PrefferedPosition","content":"pub type PrefferedPosition {\n  TopLeft\n  TopCenter\n  TopRight\n  RightTop\n  RightCenter\n  RightBottom\n  BottomLeft\n  BottomCenter\n  BottomRight\n  LeftTop\n  LeftCenter\n  LeftBottom\n}\n\nTopLeft\n\n\nTopCenter\n\n\nTopRight\n\n\nRightTop\n\n\nRightCenter\n\n\nRightBottom\n\n\nBottomLeft\n\n\nBottomCenter\n\n\nBottomRight\n\n\nLeftTop\n\n\nLeftCenter\n\n\nLeftBottom\n\n\nSynonyms:\npopcicle.PrefferedPosition\npopcicle PrefferedPosition","url":"popcicle.html#PrefferedPosition"},{"doc":"popcicle","title":"ShowType","content":"pub type ShowType {\n  Click\n  Hover\n}\n\nClick\n\n\nHover\n\n\nSynonyms:\npopcicle.ShowType\npopcicle ShowType","url":"popcicle.html#ShowType"},{"doc":"popcicle","title":"contains","content":"pub fn contains(element: Element, other: Element) -&gt; Bool\n\nSynonyms:\npopcicle.contains\npopcicle contains","url":"popcicle.html#contains"},{"doc":"popcicle","title":"default_config","content":"pub fn default_config() -&gt; PopcicleConfig\n\nSynonyms:\npopcicle.default_config\npopcicle default_config","url":"popcicle.html#default_config"},{"doc":"popcicle","title":"initialize","content":"pub fn initialize(\n  config: PopcicleConfig,\n  cb: fn() -&gt; Element(a),\n) -&gt; Element(a)\n\nSynonyms:\npopcicle.initialize\npopcicle initialize","url":"popcicle.html#initialize"},{"doc":"popcicle","title":"popcicle","content":"pub fn popcicle(\n  child: Element(a),\n  position: PrefferedPosition,\n  popcicle: Element(a),\n  show_on: ShowType,\n) -&gt; Element(a)\n A simple popcicle will add the element in the child parameter where the\n function is called. Then when that element is pressed (show_on=popcicle.Click) or\n hovered (show_on=popcicle.Hover), it will show the popcicle as a popover\n positioned by the position parameter. By default the popcicle and it&#39;s\n button comes completely unstyled and you *can* use it that way however, it\n is highly recommened you create your own styled functions. If you don&#39;t\n want to do that then there is a prestyled component based on shadcn/ui that\n you can simply copy into your project: [Dropdown Menu](https://github.com/dinkelspiel/popcicle/blob/master/examples/dropdown_menu.gleam)\n\nSynonyms:\npopcicle.popcicle\npopcicle popcicle","url":"popcicle.html#popcicle"},{"doc":"popcicle","title":"popcicle","content":"","url":"popcicle.html"}]);